class CostPerPhaseAndResources(PWReportPage):
	def init(self):
		super(CostPerPhaseAndResources, self).init()
		self.project				= None
		self.withObjective			= True
		self.withUnassigned         = 0
		self.contentMode			= 0
		self.iterIndex				= 0
		self.iterPhase				= None
		self.iterPhaseCostIndex	    = 0
		self.iterPhaseCost			= None
		self.iterPhaseResIndex		= 0
		self.iterPhaseRes			= None

		return self

	def showPlannedValues(self):
		return self.contentMode == 0 or self.contentMode == 2
		
	def showActualValues(self):
		return self.contentMode == 1 or self.contentMode == 2

	def showPlannedAndActualValues(self):
		return self.contentMode == 2
		
	def showOnlyPlannedValues(self):
		return self.contentMode == 0

	def showOnlyActualValues(self):
		return self.contentMode == 1

	def showObjective(self):
		return self.project.itemDescription()


	def topPhasesResources(self):
		return self.project.sortedMasterResources()


	def unassignedCostPerRhase(self, property):
		result = 0.0
		amountPerResource = 0.0		
		amountPerPhase = self.iterPhase.valueForKey_(property)
		if amountPerPhase != None:
			assignments = self.iterPhase.valueForKey_("assignmentsDeep")
			for anassignment in assignments:
				aamount = anassignment.valueForKey_(property)
				if aamount == None:
					aamount = 0.0
				amountPerResource = amountPerResource + aamount
		
			result = amountPerPhase - amountPerResource
			if result > 0:
				return result
	def costPerResource(self, property):
	
		amountPerResource = 0.0		
		assignments = self.iterPhase.valueForKey_("assignmentsDeep")
		theResource = self.iterPhaseRes.valueForKey_("title")
		for anassignment in assignments:
			atitle = anassignment.valueForKey_("title")
			atitle = atitle.strip()
			if theResource == atitle:
				aamount = anassignment.valueForKey_(property)
				if aamount == None:
					aamount = 0.0
				amountPerResource = amountPerResource + aamount		
		if amountPerResource > 0:
			return amountPerResource


	def masterResourePlannedCostsPerPhase(self):
		return self.costPerResource("plannedWorkCost")

	def masterResoureActualCostsPerPhase(self):
		return self.costPerResource("actualWorkCost")
		
	def unassignedPlannedCostPerRhase(self):
		return self.unassignedCostPerRhase("plannedWorkCost")

	def unassignedActualCostPerRhase(self):
		return self.unassignedCostPerRhase("actualWorkCost")



	def topPhases(self):
		activities = self.project.visibleSubActivitiesArray()
		startDateDescriptor = NSSortDescriptor.alloc().initWithKey_ascending_("plannedStartDate", True)
		if activities:
			return activities.sortedArrayUsingDescriptors_([startDateDescriptor])
		else:
			return NSArray.array()
	
	def costsPerPhase(self, property):
		amountPerResource = {}
		result = NSMutableArray.array()
		assignments = self.iterPhase.valueForKey_("assignmentsDeep")
		for anassignment in assignments:
			atitle = anassignment.valueForKey_("title")
			aamount = anassignment.valueForKey_(property)
			if aamount == None:
				aamount = 0.0
			oldAmount = amountPerResource.get(atitle)
			if oldAmount == None:
				amountPerResource[atitle] = aamount
			else:
				amountPerResource[atitle] = oldAmount + aamount		
		for key in amountPerResource.keys():
			dict = {}
			dict["name"] = key
			dict["value"] = amountPerResource[key]
			result.append(dict)
		byName = NSSortDescriptor.alloc().initWithKey_ascending_("name", True)
		return result.sortedArrayUsingDescriptors_([byName])
	
	def ResoureCostsPerPhase(self):
		return self.costsPerPhase("plannedWorkCost")

	def ResoureActualCostsPerPhase(self):
		return self.costsPerPhase("actualWorkCost")

	def rowClass(self):
		if self.iterIndex%2:
			return "even"

	def totalRowClass(self):
		if len(self.topPhases())%2:
			return "even"

	def dateFormat(self):
		return "medium/short"


	def cellClassForAmount(self, amount):
		if amount < 0:
			return "negativeBalance"
		else:
			return "positiveBalance"

